Bug 1638743 - Review Request: erlang-rebar3 - Tool for working with Erlang projects
Summary: Review Request: erlang-rebar3 - Tool for working with Erlang projects
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Peter Lemenkov
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 1638979
Blocks: 1434779
TreeView+ depends on / blocked
 
Reported: 2018-10-12 11:25 UTC by Timothée Floure
Modified: 2018-12-12 15:37 UTC (History)
4 users (show)

Fixed In Version: erlang-rebar3-3.6.2-1.fc30
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-12-12 15:37:48 UTC
Type: ---
lemenkov: fedora-review+


Attachments (Terms of Use)

Description Timothée Floure 2018-10-12 11:25:10 UTC
Spec URL: https://fnux.fedorapeople.org/pkg-reviews/erlang-rebar3/1/erlang-rebar3.spec
SRPM URL: https://fnux.fedorapeople.org/pkg-reviews/erlang-rebar3/1/erlang-rebar3-3.6.2-1.fc30.src.rpm
Description: Rebar3 is an Erlang tool that makes it easy to create, develop, and release Erlang libraries, applications, and systems in a repeatable manner. 

Fedora Account System Username: fnux

Comment 1 Randy Barlow 2018-10-13 18:09:26 UTC
For the record, the bootstrapping exception was approved here: https://pagure.io/packaging-committee/issue/788

Comment 2 Robert-André Mauchin 2018-10-19 16:19:47 UTC
 - These some MIT in there:

Expat License
-------------
rebar3-3.6.2/src/rebar3.erl
rebar3-3.6.2/src/rebar_app_utils.erl
rebar3-3.6.2/src/rebar_base_compiler.erl
rebar3-3.6.2/src/rebar_config.erl
rebar3-3.6.2/src/rebar_core.erl
rebar3-3.6.2/src/rebar_erlc_compiler.erl
rebar3-3.6.2/src/rebar_file_utils.erl
rebar3-3.6.2/src/rebar_log.erl
rebar3-3.6.2/src/rebar_otp_app.erl
rebar3-3.6.2/src/rebar_prv_escriptize.erl
rebar3-3.6.2/src/rebar_prv_install_deps.erl
rebar3-3.6.2/src/rebar_prv_shell.erl
rebar3-3.6.2/src/rebar_templater.erl
rebar3-3.6.2/src/rebar_utils.erl


  Add it to the License field.




Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "*No copyright* Apache License (v2.0)", "BSD 3-clause "New" or
     "Revised" License", "Expat License", "Unknown or generated", "Apache
     License (v2.0)". 217 files have unknown license. Detailed output of
     licensecheck in /home/bob/packaging/review/erlang-rebar3/review-
     erlang-rebar3/licensecheck.txt
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: erlang-rebar3-3.6.2-1.fc30.x86_64.rpm
          erlang-rebar3-3.6.2-1.fc30.src.rpm
erlang-rebar3.x86_64: E: no-binary
erlang-rebar3.x86_64: W: only-non-binary-in-usr-lib
erlang-rebar3.x86_64: W: manual-page-warning /usr/share/man/man1/rebar3.1.gz 52: warning: macro `this' not defined
erlang-rebar3.src: W: invalid-url Source1: rebar3-bin-3.6.2.tar.gz
2 packages and 0 specfiles checked; 1 errors, 3 warnings.

Comment 4 Peter Lemenkov 2018-12-12 13:50:10 UTC
Ok, let's review it finally. I must admit - this isn't ideal package but I believe we'd better to include it, snart using (we already have packages which require rebar3), and improve it according to feedback from the packagers.

REVIEW:

[+] rpmlint produces only messages which can be ignored:

Auriga ~: rpmlint erlang-rebar3-3.6.2-1.fc30.*
erlang-rebar3.src: W: invalid-url Source1: rebar3-bin-3.6.2.tar.gz

^^^ We're bootstrapping it so this is expected.

erlang-rebar3.x86_64: E: no-binary
erlang-rebar3.x86_64: W: only-non-binary-in-usr-lib

^^^ This is expected. See this link for explanation - https://fedoraproject.org/wiki/User:Peter/Erlang_Packaging_Guidelines#Debug_symbols_.2F_source_installation_.2F_dialyzer

erlang-rebar3.x86_64: W: manual-page-warning /usr/share/man/man1/rebar3.1.gz 52: warning: macro `this' not defined

^^^ Looks like this should be reported upstream. But I don't see it as a blocker.

2 packages and 0 specfiles checked; 1 errors, 3 warnings.
Auriga ~: 


[+] The package is named according to the Package Naming Guidelines.
[+] The spec file name matches the base package %{name}, in the format %{name}.spec.

[+/-] The package meets the Packaging Guidelines. We didn't promote Erlang Packaging Guidelines to official guidelines yet, so I've decided to omit considering them at this stage.

[+] The package is licensed with a Fedora approved license and meets the Licensing Guidelines.
[+] The License field in the package spec file matches the actual license. I can't find BSD-licensed files as stated in the comment 2. 
[+] The file, containing the text of the license(s) for the package, is included in %doc and marked as %license.
[+] The spec file is written in American English.
[+] The spec file for the package is legible.
[+] The sources used to build the package matches the upstream source, as provided in the spec URL.

Auriga ~/rpmbuild/SOURCES: sha512sum rebar3-3.6.2.tar.gz 3.6.2.tar.gz 
94b2826ae1aa5679c6582bb7cc17a892f621f110b1042d69e0c63219e384c43fb2c090faa4828be2af48fab826c1f34842a6d84d24f66852e60a7f8a419a616a  rebar3-3.6.2.tar.gz
94b2826ae1aa5679c6582bb7cc17a892f621f110b1042d69e0c63219e384c43fb2c090faa4828be2af48fab826c1f34842a6d84d24f66852e60a7f8a419a616a  3.6.2.tar.gz
Auriga ~/rpmbuild/SOURCES:

[+] The package successfully compiles and builds into binary rpms. Here is a Koji scratchbuild for Fedora 30 - https://koji.fedoraproject.org/koji/taskinfo?taskID=31423403
[+] All build dependencies are listed in BuildRequires.
[0] No need to handle locales.
[0] The package does not contain any shared library files.
[+] Packages does not bundle copies of system libraries.
[+] The package isn't designed to be relocatable.
[+] The package owns all directories that it creates.
[+] The package does not list a file more than once in the spec file's %files listings.
[+] Permissions on files are set properly.
[+] The package consistently uses macros.
[+] The package contains code, or permissible content.
[0] No large documentation files.
[+] Anything, the package includes as %doc, does not affect the runtime of the application.
[0] No static libraries.
[0] No -devel sub-package.
[+] The package does not contain any .la libtool archives.
[0] Not a GUI application.
[+] The package does not own files or directories already owned by other packages.
[+] All filenames in rpm packages are valid UTF-8.


APPROVED.

Comment 5 Gwyn Ciesla 2018-12-12 14:46:47 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/erlang-rebar3


Note You need to log in before you can comment on or make changes to this bug.